<script lang="ts">
import Vue, { PropType } from 'vue';
import type { BaseForm } from '~/interfaces';
import { marketoValidationMixin } from '~/mixins';

interface Btn {
  text: string;
  href: string;
  dataGaName: string;
  dataGaLocation: string;
  variant: string;
}

export default Vue.extend({
  name: 'AwsMarketoForm',
  mixins: [marketoValidationMixin],
  props: {
    data: {
      type: Object as PropType<BaseForm>,
      required: true,
    },
    errorMessage: {
      type: String,
      required: false,
      default: 'Sorry! Something went wrong.',
    },
    primaryBtn: {
      type: Object as PropType<Btn>,
      required: false,
      default: () => ({
        text: 'Learn more about Ultimate',
        href: '/pricing/ultimate/',
        dataGaName: 'ultimate',
        dataGaLocation: 'body',
        variant: 'primary',
      }),
    },
    secondaryBtn: {
      type: Object as PropType<Btn>,
      required: false,
      default: () => ({
        text: 'Learn more about Premium',
        href: '/pricing/premium/',
        dataGaName: 'premium',
        dataGaLocation: 'body',
        variant: 'secondary',
      }),
    },
  },
  data() {
    return {
      submitted: false,
      error: false,
      userEmail: null,
    };
  },

  watch: {
    submitted(newVal) {
      if (newVal) {
        this.userEmail = sessionStorage.getItem('userEmail');
        sessionStorage.removeItem('userEmail');
      }
    },
  },
  mounted() {
    if (!this.data.formId || this.isPreview) {
      return;
    }
    window.MktoForms2.setOptions({
      formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
    });
    window.MktoForms2.loadForm(
      '//page.gitlab.com',
      '194-VVC-221',
      this.data.formId,
      (form) => {
        if (!form) {
          this.error = true;
          return;
        }

        function isBusinessEmail(email) {
          const emailDomain = email.split('@')[1];

          if (!emailDomain) {
            return null;
          }
          // These were generated from existing product usage of the past year, may not be exhaustive
          const commonPersonalDomains = [
            'gitlab.com',
            'gmail.com',
            'outlook.com',
            'qq.com',
            'hotmail.com',
            'yahoo.com',
            'mail.ru',
            '163.com',
            'proton.me',
            'protonmail.com',
            'icloud.com',
            'yandex.ru',
            'wgu.edu',
            'hotmail.com',
            'aol.com',
            'att.net',
            'googlemail.com',
            'yahoo.com',
            'comcast.net',
            'facebook.com',
            'live.com',
            'gmx.com',
            'googlemail.com',
          ];

          return !commonPersonalDomains.includes(emailDomain);
        }

        // Function to normalize and hash email
        function normalizeAndHashEmail(email) {
          try {
            const normalizedEmail = email.trim().toLowerCase();
            const encoder = new TextEncoder();
            const data = encoder.encode(normalizedEmail);

            return crypto.subtle.digest('SHA-256', data).then((hashBuffer) => {
              const hashArray = Array.from(new Uint8Array(hashBuffer));
              const hashedEmail = hashArray
                .map((byte) => byte.toString(16).padStart(2, '0'))
                .join('');

              return hashedEmail;
            });
          } catch (error) {
            return Promise.resolve(null);
          }
        }

        // Form fields to track
        const formFields = {
          email: 'Email',
        };
        form.onSuccess(() => {
          const email = form.getValues()[formFields.email];
          sessionStorage.setItem('userEmail', email);

          this.$emit('submit');
          this.submitted = true;
          this.$router.push('#submitted-message');

          this.emitSubmitSuccess(email);

          normalizeAndHashEmail(email).then((hashedEmail) => {
            // eslint-disable-next-line no-undef
            dataLayer.push({
              event: this.formName,
              mktoFormId: form.getId(),
              formHashedEmail: hashedEmail,
              valuableSignup: isBusinessEmail(email) ? '1' : '0',
              eventCallback() {
                form.getFormElem().hide();
              },
              eventTimeout: 3000,
            });
          });
          return false;
        });
        function getgacid() {
          try {
            // eslint-disable-next-line no-undef
            const tracker = ga.getAll()[0];
            return tracker.get('clientId');
          } catch (e) {
            return 'n/a';
          }
        }
        form.vals({
          gacid: getgacid(),
        });
      },
    );
  },
  methods: {
    emitSubmitSuccess(email: string) {
      this.$emit('submit-success', email);
    },
  },
});
</script>

<template>
  <div class="form_column slp-px-md-32">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js" />
    <div v-if="data.formId" class="form_container">
      <div v-if="error" class="error">
        <SlpTypography tag="p" variant="heading4-bold">{{
          errorMessage
        }}</SlpTypography>
        <div class="error-buttons">
          <SlpButton
            :data-ga-name="primaryBtn.dataGaName"
            :data-ga-location="primaryBtn.dataGaLocation"
            :variant="primaryBtn.variant"
            :href="primaryBtn.href"
          >
            {{ primaryBtn.text }}
            <SlpIcon variant="product" name="chevron-lg-right" />
          </SlpButton>
          <SlpButton
            :data-ga-name="secondaryBtn.dataGaName"
            :data-ga-location="secondaryBtn.dataGaLocation"
            :variant="secondaryBtn.variant"
            :href="secondaryBtn.href"
          >
            {{ secondaryBtn.text }}
            <SlpIcon variant="product" name="chevron-lg-right" />
          </SlpButton>
        </div>
      </div>
      <div v-else>
        <SlpTypography tag="p" variant="body2-bold" class="slp-pb-4">
          {{ data.form_subheader }}
        </SlpTypography>
        <SlpTypography
          :v-if="data.form_header"
          :tag="data.header_config?.text_tag || 'h5'"
          :variant="data.header_config?.text_variant || 'heading5-bold'"
          class="form_header slp-pb-16"
        >
          {{ data.form_header }}
        </SlpTypography>
        <hr />
        <template v-if="!submitted">
          <form
            :id="`mktoForm_${data.formId}`"
            class="mktoForm_container"
          ></form>
        </template>
        <div v-else id="submitted-message" class="submitted_message">
          <div
            id="bizible.reportUser"
            style="display: none"
            :data-email="userEmail"
          />
          <SlpIcon variant="marketing" name="tick-circle" size="64" />
          <SlpTypography tag="h3" variant="heading4-bold">
            {{
              data.submitted_message?.header ??
              'You’ve been added to the waitlist'
            }}
          </SlpTypography>
        </div>
      </div>
    </div>
    <iframe
      v-if="data.external_form"
      :src="data.external_form.url"
      :width="data.external_form.width"
      :height="data.external_form.height"
    />
  </div>
</template>

<style lang="scss" scoped>
.mktoForm {
  padding: 0;
}

.form_column {
  grid-area: form;

  @media (max-width: $breakpoint-lg) {
    margin-bottom: 3rem;
  }

  iframe {
    display: block;
    margin-left: auto;
    margin-right: auto;
    max-width: 100%;
    border: 1px solid #f2f2f2;
    border-radius: 4px;

    .sid-ltr {
      background-color: white;
    }
  }

  .form_container {
    position: relative;
    background: #ffffff;
    padding: $spacing-24;
    border: 1px solid rgba(0, 0, 0, 0.08);
    border-radius: 4px;

    .error {
      padding: $spacing-24;
    }
    .error-buttons {
      margin: $spacing-24 0 0 0;

      .slp-btn {
        &:first-of-type {
          margin-bottom: $spacing-8;
        }
        .slp-icon {
          margin-left: $spacing-8;
        }

        @media (max-width: $breakpoint-md) {
          padding: 11px $spacing-16;
          width: 100%;
          justify-content: center;

          .slp-icon {
            display: none;
          }
        }
      }
    }
  }

  .form {
    text-align: left;
  }
}

.form_header {
  font-size: 22px;
  text-align: left;
}

hr {
  color: #e8e7eb;
  border-style: solid;
  margin-bottom: 16px;
}

.required_label {
  margin: 1rem 0;
  font-size: 16px;
  @media (max-width: $breakpoint-sm) {
    padding-left: 10px;
  }
}

.submitted_message {
  display: flex;
  flex-direction: column;
  gap: $spacing-8;
  align-items: center;
  text-align: center;
  width: 100%;
  padding: 184px 0;

  @media (min-width: $breakpoint-lg) {
    &:deep {
      h3 {
        padding: 0 $spacing-48;
      }
    }
  }

  @media (max-width: $breakpoint-lg) {
    padding: 160px 10px;
  }
}
</style>

<style lang="scss">
.mktoLabel {
  text-transform: lowercase !important;

  &::first-letter {
    text-transform: uppercase;
  }
}

.mktoForm .mktoRequiredField .mktoAsterix {
  display: none !important;
}

.mktoForm .mktoRequiredField label.mktoLabel {
  text-transform: lowercase !important;

  &::first-letter {
    text-transform: uppercase;
  }
}

div.mktoErrorArrowWrap {
  display: none;
}

.mktoForm.mktoLayoutAbove input.mktoField:focus,
.mktoForm.mktoLayoutAbove select.mktoField:focus {
  box-shadow: none;
}

.mktoForm .mktoError div.mktoErrorMsg {
  background: transparent;
  color: #333;
  border: none;
  box-shadow: none;
  display: inline;
  text-shadow: none;
  font-size: 12px;
  line-height: 20px;

  span.mktoErrorDetail {
    display: inline;
  }
}

.mktoForm .mktoError {
  position: unset !important;
}

.mktoForm_container {
  padding: 0;
  width: 100% !important;

  .mktoField:not([type='radio']) {
    min-height: 48px;
  }

  .mktoFieldDescriptor .mktoFieldWrap input.mktoInvalid {
    border: 1px solid #f24f63;
  }

  .mktoFormRow {
    width: 100%;

    input:not([type='radio']) {
      width: 100%;
    }
  }

  .mktoHasWidth {
    width: 100% !important;
    margin-bottom: 16px;
  }

  .mktoFieldWrap,
  .mktoFormCol,
  #commentCapture {
    width: 100%;
    margin-bottom: 0;
  }

  .mktoLogicalField.mktoCheckboxList.mktoHasWidth {
    display: flex;

    input[type='checkbox'] {
      width: 30px !important;
    }

    label {
      margin-left: 0.5rem;
      display: flex;
      align-items: center;
    }
  }

  .mktoFieldWrap
    input:not([type='checkbox']):not([type='radio']):not([type='hidden']),
  .mktoFieldWrap select {
    width: 100% !important;
    border: 1px solid #333333;
    border-radius: 4px;
    padding: 12px 16px;
    margin-bottom: 5px;
  }

  .mktoFieldWrap label {
    float: left;
    margin-bottom: 4px;
  }

  .mktoButtonRow {
    width: 100% !important;

    .mktoButtonWrap {
      margin-left: 0 !important;
      width: 100% !important;

      button {
        width: 100% !important;
        background-color: $color-primary-200 !important;
        color: $color-text-50 !important;
        border: 1px solid $color-primary-200 !important;
        background-image: none !important;
        display: inline-block;
        padding: 4px 30px;
        font-size: 16px;
        line-height: 40px;
        min-width: 140px;
        min-height: 52px;
        border-radius: 4px;
        margin-bottom: 20px;
        cursor: pointer;
        transition: all 0.3s ease-in-out;

        &:hover {
          background-color: $color-primary-300 !important;
          color: $color-text-300 !important;
          border: 1px solid $color-primary-200 !important;
        }
      }
    }
  }

  a:not(.btn):not(.slp-btn),
  a:not(.btn):not(.slp-btn):active,
  a:not(.btn):not(.slp-btn):hover,
  a:not(.btn):not(.slp-btn):focus {
    color: #7d2bd9;
  }
}
</style>
